<?php

if ( ! function_exists( 'hiroshi_load_page_mobile_header' ) ) {
	/**
	 * Function which loads page template module
	 */
	function hiroshi_load_page_mobile_header() {
		// Include mobile header template
		echo apply_filters( 'hiroshi_filter_mobile_header_template', hiroshi_get_template_part( 'mobile-header', 'templates/mobile-header' ) ); // phpcs:ignore WordPress.Security.EscapeOutput.OutputNotEscaped
	}

	add_action( 'hiroshi_action_page_header_template', 'hiroshi_load_page_mobile_header' );
}

if ( ! function_exists( 'hiroshi_register_mobile_navigation_menus' ) ) {
	/**
	 * Function which registers navigation menus
	 */
	function hiroshi_register_mobile_navigation_menus() {
		$navigation_menus = apply_filters( 'hiroshi_filter_register_mobile_navigation_menus', array( 'mobile-navigation' => esc_html__( 'Mobile Navigation', 'hiroshi' ) ) );

		if ( ! empty( $navigation_menus ) ) {
			register_nav_menus( $navigation_menus );
		}
	}

	add_action( 'hiroshi_action_after_include_modules', 'hiroshi_register_mobile_navigation_menus' );
}
